/**
 * @file
 * Callback for jqueryJonthorntonTimepicker.
 */

(($, Drupal) => {
  /**
   * @type {Drupal~behavior}
   *
   * @prop {Drupal~behaviorAttach} attach
   *   Attaches taxonomy terms
   */
  Drupal.behaviors.jQCloud = {
    attach(context, settings) {
      const termsRendered = document.querySelectorAll(
        '.jqcloud-contents.jqcloud',
      );

      if (termsRendered.length > 0) {
        return 0;
      }

      if (typeof settings.jQCloud !== 'undefined') {
        Object.keys(settings.jQCloud).forEach(function (key) {
          if ({}.hasOwnProperty.call(settings.jQCloud, key)) {
            const data = settings.jQCloud[key];
            const units = 'px';
            const dataHeight = `${data.height}${units}`;
            const $el = $(`.${key}.jqcloud-contents`);
            const termsClassNames = `${key} jqcloud-contents`;
            const termsArea = document.getElementsByClassName(termsClassNames);

            termsArea[0].style.height = dataHeight;

            const options = {};

            if (typeof data.colors !== 'undefined') {
              options.colors = data.colors;
            }

            // Other settings.
            options.autoResize = data.auto_resize;
            options.shape = data.shape;
            options.delay = data.delay;

            $el.jQCloud(Object.values(data.terms), options);
          }
        });
      }
    },
  };
})(jQuery, Drupal);
